org.keycloak.services

## Class DefaultComponentFactoryProviderFactory

- java.lang.Object
- - org.keycloak.services.DefaultComponentFactoryProviderFactory

- All Implemented Interfaces:
    ComponentFactoryProviderFactory, InvalidationHandler, ProviderFactory<ComponentFactoryProvider>

      public class DefaultComponentFactoryProviderFactory
      extends Object
      implements ComponentFactoryProviderFactory

  Author:
    hmlnarik

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.keycloak.provider.InvalidationHandler

      `InvalidationHandler.InvalidableObjectType, InvalidationHandler.ObjectType`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `PROVIDER_ID`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultComponentFactoryProviderFactory()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` This is called when the server shuts down.
    `String` | `getId()`
    `<T extends Provider> ProviderFactory<T>` | `getProviderFactory(Class<T> clazz, String realmId, String componentId, Function<KeycloakSessionFactory,ComponentModel> modelGetter)`
    `void` | `init(Config.Scope config)` Only called once when the factory is first created.
    `protected <T extends Provider> ProviderFactory<T>` | `initializeFactory(Class<T> clazz, String realmId, String componentId, ProviderFactory newFactory, ComponentModelScope configScope)`
    `void` | `invalidate(InvalidationHandler.InvalidableObjectType type, Object... ids)` Invalidates intermediate states of the given objects
    `void` | `postInit(KeycloakSessionFactory factory)` Called after all provider factories have been initialized

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.keycloak.component.ComponentFactoryProviderFactory

      `create`

    - ### Methods inherited from interface org.keycloak.provider.ProviderFactory

      `order`

- - ### Field Detail

    - #### PROVIDER_ID

          public static final String PROVIDER_ID

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### DefaultComponentFactoryProviderFactory

          public DefaultComponentFactoryProviderFactory()

  - ### Method Detail

    - #### init

          public void init(Config.Scope config)

      Description copied from interface: `ProviderFactory`
      Only called once when the factory is first created. This config is pulled from keycloak_server.json
      Specified by:
        `init` in interface `ProviderFactory<ComponentFactoryProvider>`

    - #### postInit

          public void postInit(KeycloakSessionFactory factory)

      Description copied from interface: `ProviderFactory`
      Called after all provider factories have been initialized
      Specified by:
        `postInit` in interface `ProviderFactory<ComponentFactoryProvider>`

    - #### getProviderFactory

          public <T extends Provider> ProviderFactory<T> getProviderFactory(Class<T> clazz,
                                                                            String realmId,
                                                                            String componentId,
                                                                            Function<KeycloakSessionFactory,ComponentModel> modelGetter)

      Specified by:
        `getProviderFactory` in interface `ComponentFactoryProviderFactory`

    - #### initializeFactory

          protected <T extends Provider> ProviderFactory<T> initializeFactory(Class<T> clazz,
                                                                              String realmId,
                                                                              String componentId,
                                                                              ProviderFactory newFactory,
                                                                              ComponentModelScope configScope)

    - #### invalidate

          public void invalidate(InvalidationHandler.InvalidableObjectType type,
                                 Object... ids)

      Description copied from interface: `InvalidationHandler`
      Invalidates intermediate states of the given objects
      Specified by:
        `invalidate` in interface `InvalidationHandler`
      Parameters:
        `type` - Type of the objects to invalidate
        `ids` - Identifiers of the invalidated objects

    - #### getId

          public String getId()

      Specified by:
        `getId` in interface `ProviderFactory<ComponentFactoryProvider>`

    - #### close

          public void close()

      Description copied from interface: `ProviderFactory`
      This is called when the server shuts down.
      Specified by:
        `close` in interface `ProviderFactory<ComponentFactoryProvider>`

Copyright © 2021 JBoss by Red Hat. All rights reserved.